Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Image Class Reference

Platform independend definition of an image class. More...

`#include <Image.h>`

Inheritance diagram for Image:

[legend]
Collaboration diagram for Image:

[legend]
List of all members.

## Public Member Functions
| Image ()
| constructs an image
| ~Image ()
| deconstructs an image
bool | hasColorTable (void)
void | setColorTable (const ColorTable *ct)
char | getClassifiedColor (int x, int y) const
char | getClassifiedColor (unsigned long index) const
void | convertFromYCbCrToRGB (const Image &ycbcrImage)
| Converts an YCbCr image into an RGB image.
void | convertFromRGBToYCbCr (const Image &rgbImage)
| Converts an RGB image into an YCbCr image.
void | convertFromYCbCrToHSI (const Image &ycrcbImage)
| Converts an YCbCr image into a HSI image.
void | convertFromHSIToYCbCr (const Image &hsiImage)
| Converts a HSI image into an YCbCr image.
void | convertFromYCbCrToTSL (const Image &ycbcrImage)
| Converts an YCbCr image into a TSL image.
unsigned char | getHighResY (int x, int y) const
| Returns the high resolution y value of a pixel.
void | setHighResY (int x, int y, unsigned char tl, unsigned char bl, unsigned char tr, unsigned char br)
| Sets the high resolution y values for one pixel in low resolution.
Image & | operator= (const Image &other)
| Assignment operator.
void | setCameraInfo ()
| set values in CameraInfo according to image size
## Public Attributes
unsigned char | image [cameraResolutionHeight_ERS7][6][cameraResolutionWidth_ERS7]
| representation for an image height color width point of origin is the upper left corner, height is positive downwards and width positive to the right the color values are in the order Y,U,V, 3xY in a higher resolution
CameraInfo | cameraInfo
unsigned long | frameNumber
| the frame number of that image
const ColorTable * | colorTable
| associated color table

## Detailed Description

Platform independend definition of an image class.

Definition at line 24 of file Image.h.

## Constructor & Destructor Documentation

Image::Image | ( |  | ) |

| constructs an image Definition at line 13 of file Image.cpp. References CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth.

Image::~Image | ( |  | ) |

| deconstructs an image Definition at line 27 of file Image.cpp.

## Member Function Documentation

bool Image::hasColorTable | ( | void |  | ) |

| Definition at line 31 of file Image.cpp. References colorTable.

void Image::setColorTable | ( | const ColorTable * | ct | ) |

| Definition at line 41 of file Image.cpp. References colorTable.

char Image::getClassifiedColor | ( | int | x,
|  | int | y
| ) | const

| Definition at line 47 of file Image.cpp. References colorTable, and ColorTable::getColorClass().

Here is the call graph for this function:

char Image::getClassifiedColor | ( | unsigned long | index | ) | const

void Image::convertFromYCbCrToRGB | ( | const Image & | ycbcrImage | ) |

  | Converts an YCbCr image into an RGB image. Parameters:
  ycbcrImage | The given YCbCr image
Definition at line 54 of file Image.cpp. References cameraInfo, ColorModelConversions::fromYCbCrToRGB(), image, CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth. Referenced by LogPlayer::saveImages().

Here is the call graph for this function:

void Image::convertFromRGBToYCbCr | ( | const Image & | rgbImage | ) |

  | Converts an RGB image into an YCbCr image. Parameters:
  rgbImage | The given RGB image
Definition at line 67 of file Image.cpp. References cameraInfo, ColorModelConversions::fromRGBToYCbCr(), image, CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth.

Here is the call graph for this function:

void Image::convertFromYCbCrToHSI | ( | const Image & | ycrcbImage | ) |

  | Converts an YCbCr image into a HSI image. Parameters:
  ycrcbImage | The given YCbCr image
Definition at line 80 of file Image.cpp. References cameraInfo, ColorModelConversions::fromYCbCrToHSI(), image, CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth.

Here is the call graph for this function:

void Image::convertFromHSIToYCbCr | ( | const Image & | hsiImage | ) |

  | Converts a HSI image into an YCbCr image. Parameters:
  hsiImage | The given HSI image
Definition at line 93 of file Image.cpp. References cameraInfo, ColorModelConversions::fromHSIToYCbCr(), image, CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth.

Here is the call graph for this function:

void Image::convertFromYCbCrToTSL | ( | const Image & | ycbcrImage | ) |

  | Converts an YCbCr image into a TSL image. Parameters:
  ycbcrImage | The given YCbCr image
Definition at line 106 of file Image.cpp. References cameraInfo, ColorModelConversions::fromYCbCrToTSL(), image, CameraInfo::resolutionHeight, and CameraInfo::resolutionWidth.

Here is the call graph for this function:

unsigned char Image::getHighResY | ( | int | x,
|  | int | y
| ) | const

  | Returns the high resolution y value of a pixel. Parameters:
  x | The x coord. of the pixel in high resolution
  y | The y coord. of the pixel in high resolution
Returns: The y value of the pixel Definition at line 119 of file Image.cpp. Referenced by VLCColorCorrector::generateCorrectedImage(), SlamColorCorrector::generateCorrectedImage(), GT2005ColorCorrector::generateCorrectedImage(), ColorTable64::generateHighResColorClassImage(), and ColorTable32K::generateHighResColorClassImage().

void Image::setHighResY | ( | int | x,
|  | int | y,
|  | unsigned char | tl,
|  | unsigned char | bl,
|  | unsigned char | tr,
|  | unsigned char | br
| ) |

  | Sets the high resolution y values for one pixel in low resolution. Parameters:
  x | The x coord. of the pixel
  y | The y coord. of the pixel
  tl | The y value of the top left subpixel
  bl | The y value of the bottom left subpixel
  tr | The y value of the top right subpixel
  br | The y value of the bottom right subpixel
Definition at line 149 of file Image.cpp. Referenced by VLCColorCorrector::generateCorrectedImage(), SlamColorCorrector::generateCorrectedImage(), and GT2005ColorCorrector::generateCorrectedImage().

Image& Image::operator= | ( | const Image & | other | ) | `[inline]`

  | Assignment operator. Parameters:
  other | The other Image that is assigned to this one
Returns: A reference to this object after the assignment. Reimplemented in JPEGImage, and JPEGImage2. Definition at line 84 of file Image.h.

void Image::setCameraInfo | ( |  | ) |

| set values in CameraInfo according to image size Definition at line 171 of file Image.cpp. References ASSERT, cameraResolutionWidth_ERS210, cameraResolutionWidth_ERS7, CameraInfo::focalLength, focalLength_ERS210, focalLength_ERS7, CameraInfo::focalLengthInv, CameraInfo::focalLenPow2, CameraInfo::focalLenPow4, CameraInfo::fourthOrderRadialDistortion, fourthOrderRadialDistortion_ERS210, fourthOrderRadialDistortion_ERS7, CameraInfo::openingAngleHeight, openingAngleHeight_ERS210, openingAngleHeight_ERS7, CameraInfo::openingAngleWidth, openingAngleWidth_ERS210, openingAngleWidth_ERS7, CameraInfo::opticalCenter, opticalCenterX_ERS210, opticalCenterX_ERS7, opticalCenterY_ERS210, opticalCenterY_ERS7, CameraInfo::resolutionHeight, CameraInfo::resolutionWidth, CameraInfo::secondOrderRadialDistortion, secondOrderRadialDistortion_ERS210, secondOrderRadialDistortion_ERS7, CameraInfo::simulated, Vector2< double >::x, and Vector2< double >::y. Referenced by operator>>().

## Member Data Documentation

unsigned char Image::image[cameraResolutionHeight_ERS7][6][cameraResolutionWidth_ERS7]

| representation for an image height color width point of origin is the upper left corner, height is positive downwards and width positive to the right the color values are in the order Y,U,V, 3xY in a higher resolution Definition at line 96 of file Image.h. Referenced by SlamEdgeSpecialist::addCandidate(), GT2005EdgeSpecialist::addCandidate(), GT2004EdgeDetection::ballEdgeVote(), VLCImageProcessor::calcEdgeAngle(), SlamImageProcessor::calcEdgeAngle(), GT2005ImageProcessor::calcEdgeAngle(), GT2005PlayerSpecialist::checkForWhiteLineBetweenBlue(), GT2005PlayerSpecialist::checkForWhiteLineBetweenRed(), convertFromHSIToYCbCr(), convertFromRGBToYCbCr(), convertFromYCbCrToHSI(), convertFromYCbCrToRGB(), convertFromYCbCrToTSL(), ColorClassImage::convertToImage(), GrayScaleImage::copyChannel(), ColorCorrector::correct(), MSH2004ColorCorrector::correctPixel(), ChallengeSpecialVision::countPixels(), GT2004EdgeDetection::crossEdgeVote(), GT2005PlayerSpecialist::detectBlueRobots(), VLCGoalRecognizer::detectEdge(), GT2005GoalRecognizer::detectEdge(), VLCGoalRecognizer::detectGreenBelowGoalpost(), GT2005GoalRecognizer::detectGreenBelowGoalpost(), GT2005PlayerSpecialist::detectRedRobots(), VLCLineFinder_DeterministicApproach::doVerificationScan(), SlamBorderFinder::doVerificationScan(), GT2005LineFinder_DeterministicApproach::doVerificationScan(), VLCLineFinder_DeterministicApproach::doVerificationScanForCircle(), GT2005LineFinder_DeterministicApproach::doVerificationScanForCircle(), ImageBrightnessEstimator::execute(), BarCodeReader::execute(), GT2004EdgeDetection::fastCrossEdgeVote(), GT2004EdgeDetection::fieldEdgeVote(), FastSUSANNoiseReduction::filterPixel(), GT2005PlayerSpecialist::findBlueFootPointYAxis(), GT2005PlayerSpecialist::findRedFootPointYAxis(), SlamBeaconDetector::findSpecial(), ColorTableTSL::generateColorClassImage(), ColorTable64::generateColorClassImage(), ColorTable32K::generateColorClassImage(), VLCRobotSpecialist::generateColorspace(), GT2005RobotSpecialist::generateColorspace(), VLCColorCorrector::generateCorrectedImage(), SlamColorCorrector::generateCorrectedImage(), GT2005ColorCorrector::generateCorrectedImage(), ColorTable64::generateHighResColorClassImage(), ColorTable32K::generateHighResColorClassImage(), VLCRobotSpecialist::generatePercept(), GT2005RobotSpecialist::generatePercept(), ColorTableTSL::generateTSLDialogImage(), GT2004EdgeDetection::getColor(), VLCImageProcessor::getCoords(), SlamImageProcessor::getCoords(), GT2005ImageProcessor::getCoords(), FastSUSANNoiseReduction::getFilteredImage(), FastSUSANNoiseReduction::getFilteredPixelSpectrum(), GT2004EdgeDetection::horizontalEdgeVote(), VLCColorCorrector::init(), SlamColorCorrector::init(), GT2005ColorCorrector::init(), GT2005PlayerSpecialist::inspectColorArea(), VLCGoalRecognizer::inspectNeighbourhood(), GT2005GoalRecognizer::inspectNeighbourhood(), SUSANEdgeDetectionLite::isEdgePoint(), GuideDogRobotSpecialist::isRed(), ColorCorrector::load(), AutoShutter::makeHistogram(), VLCRobotSpecialist::noColorPixelsBetween(), GT2005RobotSpecialist::noColorPixelsBetween(), JPEGImage2::onDestInit(), JPEGImage::onDestInit(), JPEGImage2::onDestTerm(), JPEGImage::onDestTerm(), operator<<(), JPEGImage2::operator=(), JPEGImage::operator=(), operator>>(), LogPlayer::saveAMV(), LogPlayer::saveImages(), VLCRobotSpecialist::scan(), VLCImageProcessor::scan(), SlamImageProcessor::scan(), GT2005RobotSpecialist::scan(), GT2005ImageProcessor::scan(), GT2005CenterCircleFinder::scan(), VLCGoalRecognizer::scanAlongLine(), GT2005GoalRecognizer::scanAlongLine(), VLCBeaconDetector::scanForBeaconEdges(), SlamBeaconDetector::scanForBeaconEdges(), GT2005BeaconDetector::scanForBeaconEdges(), VLCBeaconDetector::scanForBeaconPart(), SlamBeaconDetector::scanForBeaconPart(), GT2005BeaconDetector::scanForBeaconPart(), SlamBeaconDetector::scanForFlagCharacterization(), VLCBeaconDetector::scanForPink(), SlamBeaconDetector::scanForPink(), GT2005BeaconDetector::scanForPink(), JPEGImage2::toImage(), JPEGImage::toImage(), and GT2004EdgeDetection::verticalEdgeVote().

CameraInfo Image::cameraInfo

| Definition at line 98 of file Image.h. Referenced by VLCLineFinder_DeterministicApproach::addCrossingsPercept(), SlamBorderFinder::addCrossingsPercept(), GT2005LineFinder_DeterministicApproach::addCrossingsPercept(), GT2004EdgeDetection::ballEdgeVote(), VLCImageProcessor::calcEdgeAngle(), SlamImageProcessor::calcEdgeAngle(), GT2005ImageProcessor::calcEdgeAngle(), VLCLineFinder_DeterministicApproach::calculateLineOnField(), SlamBorderFinder::calculateLineOnField(), GT2005LineFinder_DeterministicApproach::calculateLineOnField(), GuideDogRobotSpecialist::calculateScanLinesParallelToHorizon(), SlamBeaconDetector::characterizeNewFlag(), GT2005CenterCircleFinder::checkCircleMidpoint(), GT2005CenterCircleFinder::checkCircleMidpoint2(), SlamEdgeSpecialist::checkPoint(), GT2005EdgeSpecialist::checkPoint(), VLCBeaconDetector::clusterPinkBeaconParts(), GT2005BeaconDetector::clusterPinkBeaconParts(), VLCImageProcessor::clusterRobots(), SlamImageProcessor::clusterRobots(), convertFromHSIToYCbCr(), convertFromRGBToYCbCr(), convertFromYCbCrToHSI(), convertFromYCbCrToRGB(), convertFromYCbCrToTSL(), ColorClassImage::convertToImage(), GrayScaleImage::copyChannel(), ColorCorrector::correct(), GT2004EdgeDetection::crossEdgeVote(), GT2005PlayerSpecialist::detectBlueRobots(), GT2005PlayerSpecialist::detectRedRobots(), VLCCenterCircleFinder::determineCirclePoint(), VLCLineFinder_DeterministicApproach::doVerificationScan(), SlamBorderFinder::doVerificationScan(), GT2005LineFinder_DeterministicApproach::doVerificationScan(), VLCLineFinder_DeterministicApproach::doVerificationScanForCircle(), GT2005LineFinder_DeterministicApproach::doVerificationScanForCircle(), ImageBrightnessEstimator::execute(), BarCodeReader::execute(), VLCImageProcessor::execute(), VLCBeaconDetector::execute(), SlamImageProcessor::execute(), SlamBeaconDetector::execute(), GuideDogRobotSpecialist::execute(), GT2005ImageProcessor::execute(), GT2005BeaconDetector::execute(), GT2004EdgeDetection::fieldEdgeVote(), VLCLineFinder_DeterministicApproach::findIntersections(), SlamBorderFinder::findIntersections(), GT2005LineFinder_DeterministicApproach::findIntersections(), VLCLineFinder_DeterministicApproach::findLines(), SlamBorderFinder::findLines(), GT2005LineFinder_DeterministicApproach::findLines(), SlamBeaconDetector::findSpecial(), GT2004EdgeDetection::findStart(), ColorTableTSL::generateColorClassImage(), ColorTable64::generateColorClassImage(), ColorTable32K::generateColorClassImage(), VLCRobotSpecialist::generateColorspace(), GT2005RobotSpecialist::generateColorspace(), VLCColorCorrector::generateCorrectedImage(), SlamColorCorrector::generateCorrectedImage(), GT2005ColorCorrector::generateCorrectedImage(), ColorTable64::generateHighResColorClassImage(), ColorTable32K::generateHighResColorClassImage(), VLCRobotSpecialist::generatePercept(), GT2005RobotSpecialist::generatePercept(), ColorTableTSL::generateTSLDialogImage(), GT2004EdgeDetection::getColor(), SlamEdgeSpecialist::getEdgesPercept(), GT2005EdgeSpecialist::getEdgesPercept(), FastSUSANNoiseReduction::getFilteredImage(), VLCLineFinder_DeterministicApproach::handleCenterCircle(), GT2005LineFinder_DeterministicApproach::handleCenterCircle(), GT2004EdgeDetection::horizontalEdgeVote(), VLCColorCorrector::init(), SlamColorCorrector::init(), GT2005ColorCorrector::init(), GT2004EdgeDetection::insideImage(), VLCGoalRecognizer::interpretResults(), ColorCorrector::load(), VLCRobotSpecialist::noColorPixelsBetween(), GT2005RobotSpecialist::noColorPixelsBetween(), JPEGImage2::onDestInit(), JPEGImage::onDestInit(), operator<<(), JPEGImage2::operator=(), JPEGImage::operator=(), operator>>(), GT2005GoalRecognizer::publishResults(), LogPlayer::saveAMV(), LogPlayer::saveImages(), VLCRobotSpecialist::scan(), VLCImageProcessor::scan(), SlamImageProcessor::scan(), GT2005RobotSpecialist::scan(), GT2005ImageProcessor::scan(), GT2005CenterCircleFinder::scan(), SlamImageProcessor::scanColumns(), GT2004EdgeDetection::scanEast(), SlamBeaconDetector::scanForFlagCharacterization(), GuideDogRobotSpecialist::scanParallelToHorizon(), GT2004EdgeDetection::scanSouth(), GT2005CenterCircleFinder::scanSurrounding(), GT2004EdgeDetection::susanVote(), JPEGImage2::toImage(), JPEGImage::toImage(), and GT2004EdgeDetection::verticalEdgeVote().

unsigned long Image::frameNumber

| the frame number of that image Definition at line 101 of file Image.h. Referenced by VLCImageProcessor::execute(), SlamImageProcessor::execute(), GT2005ImageProcessor::execute(), FastSUSANNoiseReduction::getFilteredImage(), VLCColorCorrector::init(), SlamColorCorrector::init(), GT2005ColorCorrector::init(), ColorCorrector::load(), GT2005GoalRecognizer::notifyAboutNewImage(), GTCamTimeSyncHandler::onReceive(), operator<<(), JPEGImage2::operator=(), JPEGImage::operator=(), operator>>(), GTCamTimeSyncHandler::startTimeSync(), JPEGImage2::toImage(), and JPEGImage::toImage().

const ColorTable* Image::colorTable

| associated color table Definition at line 104 of file Image.h. Referenced by VLCColorCorrector::generateCorrectedImage(), SlamColorCorrector::generateCorrectedImage(), GT2005ColorCorrector::generateCorrectedImage(), getClassifiedColor(), FastSUSANNoiseReduction::getFilteredImage(), hasColorTable(), JPEGImage2::operator=(), and setColorTable().

The documentation for this class was generated from the following files:

- Representations/Perception/Image.h
- Representations/Perception/Image.cpp